/*
** chipregs.h -- This header defines some macros and pointers for the various
**		 Amiga custom hardware registers.  The naming conventions
**		 used here conform to those used in the Amiga Hardware
**		 Reference Manual, 3rd Edition
**
** Copyright 1992 by Greg Harp
**
** This file is subject to the terms and conditions of the GNU General Public
** License.  See the file README.legal in the main directory of this archive
** for more details.
**
** Created: 9/24/92 by Greg Harp
*/

#ifndef _AMIGA_CHIPREGS_H_
#define _AMIGA_CHIPREGS_H_

#include <linux/types.h>

struct CUSTOM {
    u_short bltddat;
    u_short dmaconr;
    short   vposr;
    u_short vhposr;
    u_short dskdatr;
    u_short joy0dat;
    u_short joy1dat;
    u_short clxdat;
    u_short adkconr;
    u_short pot0dat;
    u_short pot1dat;
    u_short potgor;
    u_short serdatr;
    u_short dskbytr;
    u_short intenar;
    u_short intreqr;
    u_char  *dskptr;
    u_short dsklen;
    u_short dskdat;
    u_short refptr;
    u_short vpsow;
    u_short vhposw;
    u_short copcon;
    u_short serdat;
    u_short serper;
    u_short potgo;
    u_short joytest;
    u_short strequ;
    u_short strvbl;
    u_short strhor;
    u_short strlong;
    u_short bltcon0;
    u_short bltcon1;
    u_short bltafwm;
    u_short bltalwm;
    u_char  *bltcpt;
    u_char  *bltbpt;
    u_char  *bltapt;
    u_char  *bltdpt;
    u_short bltsize;
    u_short spare1[3];
    u_short bltcmod;
    u_short bltbmod;
    u_short bltamod;
    u_short bltdmod;
    u_short spare2[4];
    u_short bltcdat;
    u_short bltbdat;
    u_short bltadat;
    u_short spare3[4];;
    u_short dsksync;
    u_short *cop1lc;
    u_short *cop2lc;
    u_short copjmp1;
    u_short copjmp2;
    u_short copins;
    u_short diwstrt;
    u_short diwstop;
    u_short ddfstrt;
    u_short ddfstop;
    u_short dmacon;
    u_short clxcon;
    u_short intena;
    u_short intreq;
    u_short adkcon;
    struct {
	u_char  *audlc;
	u_short audlen;
	u_short audper;
	u_short audvol;
	u_short auddat;
	u_short audspare[2];
    } aud[4];
    u_char  *bplpt[6];
    u_short spare5[4];
    u_short bplcon0;
    u_short bplcon1;
    u_short bplcon2;
    u_short spare6;
    u_short bpl1mod;
    u_short bpl2mod;
    u_short spare7[2];
    u_short bpldat[6];
    u_short spare8[2];
    u_char  *sprpt[8];
    struct {
	u_short pos;
	u_short ctl;
	u_short dataa;
	u_short datab;
    } spr[8];
    u_short color[32];
};

struct CIA {
    u_char pra;			char pad0[0xff];
    u_char prb;			char pad1[0xff];
    u_char ddra;		char pad2[0xff];
    u_char ddrb;		char pad3[0xff];
    u_char talo;		char pad4[0xff];
    u_char tahi;		char pad5[0xff];
    u_char tblo;		char pad6[0xff];
    u_char tbhi;		char pad7[0xff];
    u_char todlo;		char pad8[0xff];
    u_char todmid;		char pad9[0xff];
    u_char todhi;		char pada[0x1ff];
    u_char sdr;			char padb[0xff];
    u_char icr;			char padc[0xff];
    u_char cra;			char padd[0xff];
    u_char crb;			char pade[0xff];
};
    
extern caddr_t CustomBase;
#define CUSTOM_PHYSADDR     (0xdff000)
#define custom ((*(volatile struct CUSTOM *)CustomBase))

extern caddr_t CiaABase;
extern caddr_t CiaBBase;
#define CIAA_PHYSADDR     (0xbfe001)
#define CIAB_PHYSADDR     (0xbfd000)
#define ciaa   ((*(volatile struct CIA *)CiaABase))
#define ciab   ((*(volatile struct CIA *)CiaBBase))

#endif /* amiga/chipregs.h */
